/******************************************************/
/*  FILE        :clock1.c
/*@ ṽvO@No1
/*@@^C}X1.0bC^[oŎvXV
/*    ԊOM@̃R}hŎƃ^C}ݒ
/******************************************************/
#include	<sfr_r815.h>			// wb_t@CCN[h 
#define		CLOCK	20000
#include	<lcd_lib02.c>			// t\탉CuCN[h

/// O[oϐ
char SecCounter;					// PbJE^
char SecFlag;						// PbtO
char Second;						// @b
char Minute;						// @
char Hour;							// @
char ALMNum;						// ^C}ݒԍ
char SetHour;						// ^C}ݒ
char SetMin;
char SetSec;
char SetCont;
char SetPos;						// ݒʒuw
char MsgKind;						// bZ[WʃtO
char ApState;						// ݒ菈tO

#define	MaxBit	11					// ԊOrbg
#define Device 0x04					// foCXR[h
char StateFlag;						// ԊOMtO
char BitCounter;					// ԊOrbgJE^
char Command;						// ԊOf[^R[h

/// \bZ[Wobt@
char MsgTime[] = "Time hh:mm:ss   \0";
char MsgSet[]  = "Set  hh:mm:ss   \0";
char MsgALM[]  = "ALM# hh:mm:ss On\0";
char MsgSpace[] ="                \0";
char MsgCNT[] =  "Out Control  CLR\0";

/// ԊOMobt@
char FirstData[MaxBit+1];			// Mf[^
char SecData[MaxBit+1];				// Af[^

/// ^C}i[obt@
struct Alarm
{
	char Hour;						// ݒ莞
	char Min;
	char Sec;
	char Cont;						// s
};
struct Alarm ALMBuff[10];			// 10̃f[^
	
/// vg^CsO
void Init(void);
void UpDate(void);
void CheckTimer(void);
void DisplayTime(void);
void itostring(int digit, unsigned long data, char *buffer);
char CheckData(void);
void SetupMsg(char kind);
void Process(char Command);
void SetPlus(char set);
void SetMinus(char set);

///////////////////////////////////////////////////
///^C}X荞ݏ(b荞ݗpj
///40msecŊ荞ݔA25łPb
#pragma interrupt timer_x					// 荞ݏ錾
void	timer_x(void)
{
	if(!SecCounter)							// Pbo߂H
	{
		SecFlag = 1;						// Pbo߃tO
		SecCounter = 39;					// JE^ăZbg
	}
	SecCounter--;							// 荞݃JE^|P
}

///////////////////////////////////////////////////
/// ^C}Z荞ݏ֐iԊOMpj
///@1000secŊ荞ݔ
#pragma interrupt timer_z
void	timer_z(void)
{
	switch(StateFlag)
	{
		case 1:								// Pڃf[^H
			FirstData[BitCounter] = !p1_4;	// f[^M
			BitCounter++;					// M

			if(BitCounter > MaxBit)			// SrbgM
			{
				StateFlag = 2;				// Xe[gXV
				BitCounter = 0;
			}
			break;
		case 2:
			if(p1_4)						// gC`FbN
			{
				BitCounter++;
				if(BitCounter > 5)			// gC
				{
					BitCounter = 0;			// Xe[gZbg
					StateFlag = 0;
					tzs = 0;
				}
			}
			else 							// 2ڂ̃X^[grbgo
			{
				StateFlag = 3;				// ̃Xe[g
				BitCounter = 0;
			}
			break;
		case 3:	
			p1_6 = ! p1_6;
			SecData[BitCounter] = !p1_4;	// AQubNڃf[^M
			BitCounter++;					// rbgJEgXV
			if(BitCounter > MaxBit)			// SrbgM
			{
				tzs = 0;					// ^C}Z~
				StateFlag = 4;				// IXe[gɃZbg
			}
		case 4: break;
		default :
			BitCounter = 0;					// Xe[gZbg
			StateFlag = 0;
			tzs = 0;			
			break;
	}
}

////////////////////////////////////////////////////////////////
///@C֐
void main(void)
{
	/// I/O
	Init();
	/// bZ[W
	lcd_init();								// LCD
	lcd_str("Start!\0");					// bZ[W
	txs = 1;								// Pb^C}Jn
	///荞݋
	asm("FSET I");
	///C[`
	while(1)
	{
		/// JEgAbv`FbN
		if(SecFlag)							// 1bo߃`FbN
		{
			SecFlag = 0;
			UpDate();						// XV
			DisplayTime();					// t\
			CheckTimer();					// ^C}r`FbN
		}
		/// ԊOMJn`FbN
		if((StateFlag == 0) && (p1_4 == 0))
		{
			/// ŏ̃X^[grbgo
			delay(500);						// rbg҂
			if(!p1_4)						// mCY`FbN
			{
				StateFlag = 1;				// Xe[gM
				BitCounter = 0;				// rbgʒuZbg
				tzs = 1;					// ^C}ZX^[g
			}
		}
		else if(StateFlag >= 4)				// MH
		{
			//// ԊOM@L[R[h̏s
			Command = CheckData();			// f[^`FbN
			if((Command & 0xF0) != 0xF0)	// f[^킩H
			{
				p1_6 = 0;					// LED\
				p1_7 = 1;
				Process(Command);			// eL[R[h
				StateFlag = 0;				// MXe[gZbg
			}
			else							// MG[
			{
				StateFlag = 0;				// MXe[gZbg
				BitCounter = 0;
				p1_7 = 0;					// MG[LED\
				p1_6 = 1;
				tzs = 0;
			}
		}
	}
}

////////////////////////////////////////////////////
/// ԊOMf[^`FbN
char CheckData(void)
{
	char i, cmd;
	
	cmd = 0;								// ߂lZbg
	for(i=0; i<MaxBit; i++)					// QAƍ
	{
		if(FirstData[i] != SecData[i])		// QAH
			cmd = 0xF3;						// ƍsv
	}
	// ƍv̏ꍇ
	if(cmd == 0)						
	{
		/// Zp[^̃`FbN
		if((FirstData[3] == 0) && (FirstData[4] == 1))
		{
			// foCXR[h`FbN
			cmd = 0;
			for(i=0; i<3; i++)
				cmd = cmd * 2 + FirstData[i];
			if(cmd == Device)	
			{
				/// L[R[hvZ
				cmd = 0;
				for(i=0; i<5; i++)
					cmd = cmd * 2 + FirstData[i+5];
			}
			else
				cmd = 0xF1;
		}
		else
			cmd = 0xF2;				
	}
	return cmd;								// L[R[h܂FFԂ
}
	

////////////////////////////////////////////////////
/// ԊOR}h
void Process(char Command)
{
	switch(Command)
	{
		case 0:								// ݒw
			ApState = 1;					// AvXe[gP
			MsgKind = 0;					// bZ[Wʎw
			SetHour = Hour;					// ݕ\l擾
			SetMin = Minute;
			SetSec = Second;
			SetPos = 0;						// ʒuZbg
			SetupMsg(MsgKind);				// ݕ\Őݒl\
			lcd_cmd(0xC5);					// uN\
			lcd_cmd(0x0F);
			break;
		case 1:
			ApState = 2;					// AvXe[gQ
			MsgKind = 1;					// A[ݒw
			SetPos = 0;						// ʒuZbg
			ALMNum++;						// A[ԍXV
			if(ALMNum > 9)					// 0-9͈̔
				ALMNum = 0;
			SetHour = ALMBuff[ALMNum].Hour;	// ݐݒl擾
			SetMin = ALMBuff[ALMNum].Min;
			SetSec = ALMBuff[ALMNum].Sec;
			SetCont = ALMBuff[ALMNum].Cont;
			itostring(1, ALMNum, MsgALM + 3);
			SetupMsg(MsgKind);				// ݐݒl\
			lcd_cmd(0xC5);					// uN
			lcd_cmd(0x0F);
			break;
		case 2:								// w
			if(ApState == 1)				// ݒ蒆
			{
				SetPos++;					// ʒuXV
				if(SetPos > 2)				// ʒu0-2͈̔
					SetPos = 0;
				lcd_cmd(0x0E);				// Stop Blink
				lcd_cmd(0xC5 + SetPos*3);
				lcd_cmd(0x0F);				// Set Blink
			}
			if(ApState == 2)				// A[ݒ蒆
			{
				SetPos++;					// ʒuXV
				if(SetPos > 3)				// ʒu0-3͈̔
					SetPos = 0;
				lcd_cmd(0x0E);				// Stop Blink
				lcd_cmd(0xC5 + SetPos*3);
				lcd_cmd(0x0F);				// Set Blink										
			}
			break;
		case 3:								// ݒlAbv
			if((ApState == 1)||(ApState == 2))	// ݒ葀쒆̂ݎs
			{
				SetPlus(SetPos);
				SetupMsg(MsgKind);
			}
			break;
		case 4:								// ݒl_E
			if((ApState == 1)||(ApState == 2))	// ݒ葀쒆̂ݎs
			{
				SetMinus(SetPos);	
				SetupMsg(MsgKind);
			}
			break;
		case 5:								// ݒs
			if(ApState == 1)				// ݒ葀쒆̏ꍇ
			{
				Hour = SetHour;
				Minute = SetMin;
				Second = SetSec;
			}
			else if(ApState == 2)			// A[ݒ̏ꍇ
			{
				// i\́j֊i[
				ALMBuff[ALMNum].Hour = SetHour;
				ALMBuff[ALMNum].Min = SetMin;
				ALMBuff[ALMNum].Sec = SetSec;
				ALMBuff[ALMNum].Cont = SetCont;
			}
			lcd_cmd(0xC0);					// ̑̏ꍇׂĎs
			lcd_str(MsgSpace);				// \
			ApState = 0;					// ݒ葀AvI
			StateFlag = 0;
			BitCounter = 0;
			break;
		case 6:								// ڐ
			if(ApState == 0)
				ApState = 3;
			else
			{
				ApState++;
				if(ApState > 7)
					ApState = 3;
			}
			SetupMsg(ApState);
			break;
		case 7:								// ڐ
			switch(ApState)
			{
				case 4: p3_5 = 0; break;
				case 5: p3_5 = 1; break;
				case 6: p3_7 = 0; break;
				case 7: p3_7 = 1; break;
				default : break;
			}				 
			lcd_cmd(0xC0);
			lcd_str(MsgSpace);
			StateFlag = 0;					// Zbg
			BitCounter = 0;
			ApState = 0;					// Xe[gZbg
			break;
		default:
			StateFlag = 0;					// Zbg
			BitCounter = 0;
			ApState = 0;					// Xe[gZbg			
			break;
	}
}

///////////////////////////////////////////////////
///  ݒ莞Abv_E
///  ́@0:Ȃ@1:CH1It@2:CH1I
///                      3:CH2It@3:CH2I
void SetPlus(char set)
{
	switch(set)
	{
		case 0:
			SetHour++;						// Abv
			if(SetHour > 23)
				SetHour = 0;
			break;
		case 1:	
			SetMin++;						// Abv
			if(SetMin > 59)
				SetMin = 0;
			break;
		case 2:
			SetSec++;						// bAbv
			if(SetSec > 59)
				SetSec = 0;
			break;
		case 3:								// Abv
			SetCont++;
			if(SetCont > 4)
				SetCont = 0;
			break;
		default : break;
	}
}
/// ݒl_E
void SetMinus(char set)
{
	switch(set)
	{
		case 0:
			if(SetHour <= 0)
				SetHour = 23;
			else
				SetHour--;					// _E
			break;
		case 1:
			if(SetMin <= 0)
				SetMin = 59;
			else
				SetMin--;					// _E
			break;
		case 2:
			if(SetSec <= 0)
				SetSec = 59;
			else
				SetSec--;					// b_E
			break;
		case 3:
			if(SetCont <= 0)
				SetCont = 4;
			else
				SetCont--;					// _E
			break;
		default : break;
	}
}


////////////////////////////////////////////////////
/// ݒpbZ[W쐬
void SetupMsg(char kind)
{
	if(kind == 0)							// ݒ̏ꍇ
	{
		itostring(2, SetHour, MsgSet+5);	// ϊ
		itostring(2, SetMin, MsgSet+8);
		itostring(2, SetSec, MsgSet+11);
		lcd_cmd(0xC0);
		lcd_str(MsgSet);					// bZ[W\
	}
	else if(kind == 1)						// A[ݒ̏ꍇ
	{
		itostring(2, SetHour, MsgALM+5);	//ϊ
		itostring(2, SetMin, MsgALM+8);
		itostring(2, SetSec, MsgALM+11);
		if(SetCont == 0)					// ϊ
		{
			MsgALM[14] = ' ';				// 䖳̏ꍇ̓Xy[X
			MsgALM[15] = ' ';
		}
		else
			itostring(2, SetCont, MsgALM+14);
		lcd_cmd(0xC0);
		lcd_str(MsgALM);					// bZ[W\
	}
	else if(kind >=3)
	{
		switch(kind)						// 䃁bZ[W\
		{
			case 3: MsgCNT[13] = 'C';		// Ȃ
					MsgCNT[14] = 'L';
					MsgCNT[15] = 'R';
					break;
			case 4: MsgCNT[13] = '1';
					MsgCNT[14] = 'O';
					MsgCNT[15] = 'f';
					break;
			case 5: MsgCNT[13] = '1';
					MsgCNT[14] = 'O';
					MsgCNT[15] = 'n';
					break;
			case 6: MsgCNT[13] = '2';
					MsgCNT[14] = 'O';
					MsgCNT[15] = 'f';
					break;
			case 7: MsgCNT[13] = '2';
					MsgCNT[14] = 'O';
					MsgCNT[15] = 'n';
					break;
			default: break;
		}
		lcd_cmd(0xC0);						// bZ[W\
		lcd_str(MsgCNT);
	}						
}	

///////////////////////////////////////////////////
/// XVTu֐
void UpDate(void)
{
	Second++;								// bJEgAbv
	if(Second == 60)						// 60bH
	{
		Second = 0;	
		Minute++;							// JEgAbv
		if(Minute == 60)					// 60H
		{
			Minute = 0;
			Hour++;							// JEgAbv
			if(Hour == 24)					// 24H
				Hour = 0;
		}
	}
}

////////////////////////////////////////////////////
/// @t\
void DisplayTime(void)
{
	itostring(2, Hour, MsgTime + 5);
	itostring(2, Minute, MsgTime + 8);
	itostring(2, Second, MsgTime + 11);
	if(p3_5 == 1)
		MsgTime[14] = '1';
	else
		MsgTime[14] = ' ';
	if(p3_7 == 1)
		MsgTime[15] = '2';
	else
		MsgTime[15] = ' ';
	lcd_cmd(0x80);							// Psڎw
	lcd_str(MsgTime);						// \
}

////////////////////////////////////////////////////
/// ^C}v`FbN
void CheckTimer(void)
{
	char i;
	/// 10̃A[ݒr`FbN
	for(i=0; i<10; i++)	
	{
		if((ALMBuff[i].Hour == Hour) && (ALMBuff[i].Min == Minute) &&
		   (ALMBuff[i].Sec == Second))
		{
			/// vꍇ̐o
			ApState = 0;					// AvXe[gZbg
			MsgKind = 1;
			SetHour = ALMBuff[i].Hour;
			SetMin = ALMBuff[i].Min;
			SetSec = ALMBuff[i].Sec;
			SetCont = ALMBuff[i].Cont;
			itostring(1, i, MsgALM + 3);
			SetupMsg(MsgKind);				// bZ[W\
			/// s			
			switch(ALMBuff[i].Cont)
			{
				case 1:	p3_5 = 0; break;
				case 2: p3_5 = 1; break;
				case 3: p3_7 = 0; break;
				case 4: p3_7 = 1; break;
				default : break;
			}
		}
	}
}

////////////////////////////////////////////////////
///// l當ɕϊ(Char^j
void itostring(int digit, unsigned long data, char *buffer)
{
	char i;	
	buffer += digit;						//̍Ō
	for(i=digit; i>0; i--)					//ŉʌʂ
	{	
		buffer--;							//|C^[P
		*buffer = (data % 10) + '0';		//̌l𕶎ɂĊi[
		data = data / 10;					//-1
	}
}

//////////////////////////////////////////////////////
//// ֐
void Init(void)
{
	char i;

	// NbNCNbNɐ؂ւ
	prc0 = 1;								// veNg
	cm1 = 0x08;								// Xin XoutgpAȂ
	cm0 = 0x08;								// NbNUJnA1/8I
	asm("NOP");			
	asm("NOP");								// NbNU҂
	asm("NOP");
	asm("NOP");
	ocd2 = 0;								// CNbNI
	prc0 = 0;								// veNgI
	/// o̓[hݒ
	pd1 = 0xCF;								// |[go̓[hݒ
	pd3 = 0xFF;	
	pd4_5 = 0;
	p1 = 0xC0;								// LED Off
	/// ^C}X̏ݒ(25msec̃^C}[hj
	txmr = 0;								// ^C}[hݒ
	tcss = 0x01;							// NbNIf8
	prex = 250-1;							// 20MHz8250250=40Hz
	tx = 250-1;								// 249Zbg
	txic = 0x05;
	/// ^C}Z̏ݒ(800sec̃^C}[hj
	tzmr = 0;								// ^C}[h
	tcss = tcss | 0x10;						// NbNIf8
	prez = 250-1;							// 50nsec~8~250=100usec
	tzpr = 10-1;							// 100usec~10=1000usec 
	tzic = 0x06;
	/// p[^
	SecFlag = 0;
	SecCounter = 39;						// bJE^Zbg
	StateFlag = 0;							// ԊOMZbg
	BitCounter = 0;							// MrbgJE^Zbg
	ALMNum = 0;								// ^C}ݒԍ
	SetHour = 0;							// ݒ莞
	SetMin = 0;
	SetSec = 0;
	SetPos = 0;								// ݒʒu
	ApState = 0;							// AvXe[gZbg
	for(i=0; i<10; i++)						// A[ݒS
	{
		ALMBuff[i].Hour = 0;
		ALMBuff[i].Min = 0;
		ALMBuff[i].Sec = 0;
		ALMBuff[i].Cont = 4;
	}
	for(i=0; i<MaxBit; i++)					// ԊOMobt@
	{
		FirstData[i] = 0;
		SecData[i] = 0;
	}
}


